unit hiBASS_Progress;

interface

uses Kol,windows,Share,Debug,bass;

type
  THIBASS_Progress = class(TDebug)
   private
   public
    FTimer:PTimer;
    _prop_Channel:^cardinal;
    _prop_Delay: integer;

    _event_onRiValue:THI_Event;
    _event_onLeValue:THI_Event;

    procedure _work_doStartProgress(var _Data:TData; Index:word);
    procedure _work_doStopProgress(var _Data:TData; Index:word);
    procedure _work_doDelay(var _Data:TData; Index:word);
    procedure Progress(Obj:PObj);
  end;

implementation

procedure THIBASS_Progress._work_doDelay;
begin
  FTimer.Interval := ToInteger(_Data);
end;


procedure THIBASS_Progress.Progress;
var  level: DWord;
     levelL, levelR: byte;
begin
  if BASS_ChannelIsActive(_prop_Channel^) <> BASS_ACTIVE_PLAYING then Exit;
  level := BASS_ChannelGetLevel(_prop_Channel^);
  levelL := loword(level) * 100 div (maxword div 2);
  levelR := hiword(level) * 100 div (maxword div 2);
  _hi_OnEvent(_event_onRiValue,levelR);
  _hi_OnEvent(_event_onLeValue,levelL);  
end;


procedure THIBASS_Progress._work_doStartProgress;
begin
  FTimer := NewTimer(_prop_Delay);
  FTimer.Enabled := true;
  FTimer.OnTimer := Progress;
end;

procedure THIBASS_Progress._work_doStopProgress;
begin
  FTimer.Enabled := false;
  FTimer.Free;
  _hi_OnEvent(_event_onRiValue,0);
  _hi_OnEvent(_event_onLeValue,0);
end;

end.
